'From Squeakland 3.8-05 of 1 September 2005 [latest update: #527] on 26 October 2006 at 1:52:36 am'!
AlignmentMorph subclass: #ScriptEditorMorph
	instanceVariableNames: 'scriptName firstTileRow timeStamp playerScripted handWithTile showingMethodPane threadPolygon logger '
	classVariableNames: 'WritingUniversalTiles '
	poolDictionaries: ''
	category: 'Morphic-Scripting'!
MethodWithInterface subclass: #UniclassScript
	instanceVariableNames: 'currentScriptEditor formerScriptingTiles isTextuallyCoded lastSourceString logger '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scripting'!

!ScriptEditorMorph methodsFor: 'copying' stamp: 'ms 10/26/2006 01:52'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	scriptName _ scriptName veryDeepCopyWith: deepCopier.
	firstTileRow _ firstTileRow veryDeepCopyWith: deepCopier.
	timeStamp _ timeStamp veryDeepCopyWith: deepCopier.
	playerScripted _ playerScripted.		"Weakly copied"
	handWithTile _ nil.  "Just a cache"
	showingMethodPane _ showingMethodPane.	"boolean"
	threadPolygon _ nil. "Just a cache".

! !

!ScriptEditorMorph methodsFor: 'initialization' stamp: 'ms 10/26/2006 01:51'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	self listDirection: #topToBottom;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 cellPositioning: #topLeft;
		 setProperty: #autoFitContents toValue: true;
	 layoutInset: 2;
	 useRoundedCorners.
	self setNameTo: 'Script Editor' translated.
	firstTileRow _ 1.
	"index of first tile-carrying submorph"
	self addNewRow.
	showingMethodPane _ false.! !

!ScriptEditorMorph methodsFor: 'menu' stamp: 'ms 10/26/2006 00:07'!
captureScriptImage
	^ ((self logger wantsCaptureScriptImage)
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'Capture Image' translated! !

!ScriptEditorMorph methodsFor: 'menu' stamp: 'ms 10/26/2006 00:07'!
recordDebugLog
	^ ((self logger wantsRecordDebugLog)
		ifTrue: ['<yes>']
		ifFalse: ['<no>'])
		, 'Record Debug Log' translated! !

!ScriptEditorMorph methodsFor: 'menu' stamp: 'ms 10/26/2006 00:07'!
toggleCaptureScriptImage
	self logger toggleCaptureScriptImage! !

!ScriptEditorMorph methodsFor: 'menu' stamp: 'ms 10/26/2006 00:07'!
toggleRecordDebugLog
	self logger toggleRecordDebugLog! !

!ScriptEditorMorph methodsFor: 'logger' stamp: 'ms 10/26/2006 01:36'!
logger
	| aScriptInstantiation aUserScriptObject |
	aScriptInstantiation _ playerScripted scriptInstantiationForSelector: scriptName.
	aUserScriptObject _ aScriptInstantiation userScriptObject.
	^ aUserScriptObject logger.! !


!ScriptLogger methodsFor: 'logging' stamp: 'ms 10/26/2006 01:48'!
logging
	| timeStamp pngFileName recordFileName fileStream debugRecord |

	targetScriptEditor ifNil:[
		^self.
	].

	"create log directory if not exist"
	(FileDirectory default directoryExists: self defaultLogDirectory) ifFalse: [
		FileDirectory default createDirectory: (self defaultLogDirectory)
	].

	timeStamp _ self getTimeStamp.	

	"capture script"
	wantsCaptureScriptImage ifTrue:[
		pngFileName _ targetScriptEditor playerScripted getName,' ',
						targetScriptEditor scriptName,' ',timeStamp,'.png'.
		pngFileName _ self defaultLogDirectory,'\\',pngFileName.
		PNGReadWriter putForm: targetScriptEditor imageForm onFileNamed: pngFileName.
	].

	"record debug log"
	wantsRecordDebugLog ifTrue: [
		debugRecord _ nil.
		[debugRecord isEmptyOrNil] whileTrue: [
			debugRecord _ FillInTheBlank
				multiLineRequest: 'Input Debug Record' translated
				centerAt: Sensor cursorPoint
				initialAnswer: ''
				answerHeight: 100.
		].
			
		recordFileName _ targetScriptEditor playerScripted getName,' ',
						targetScriptEditor scriptName,' ',timeStamp,'.txt'.
		[fileStream _ CrLfFileStream newFileNamed: self defaultLogDirectory,'\\',recordFileName.
		fileStream nextPutAll:debugRecord.] ensure: [fileStream close.]
	].! !


!ScriptLogger class methodsFor: 'initialize' stamp: 'ms 10/26/2006 00:04'!
new: scriptEditor
	| instance |
	instance _ super new.
	instance targetScriptEditor: scriptEditor.
	^ instance.! !


!ScriptStatusControl methodsFor: 'mouse gestures' stamp: 'ms 10/26/2006 01:45'!
mouseUpTick: evt onItem: aMorph
	self removeAlarm: #offerTickingMenu:.
	aMorph color: (Color r: 0.767 g: 0.767 b: 1.0).
	(scriptInstantiation status == #ticking) ifTrue:[
		scriptInstantiation status: #paused. 
		aMorph color: (Color r: 1.0 g: 0.774 b: 0.774).
		aMorph isTicking: false.
		scriptInstantiation userScriptObject logger logging.
	] ifFalse:[
		scriptInstantiation status: #ticking. 
		aMorph color: (Color r: 0.767 g: 0.767 b: 1.0).
		aMorph isTicking: true.
	].
	scriptInstantiation updateAllStatusMorphs.! !


!UniclassScript methodsFor: 'initialization' stamp: 'ms 10/26/2006 01:37'!
initialize
	super initialize.
	isTextuallyCoded := false.
	logger _ ScriptLogger new.! !

!UniclassScript methodsFor: 'script editor' stamp: 'ms 10/26/2006 01:38'!
instantiatedScriptEditorForPlayer: t1 
	currentScriptEditor
		ifNil: [currentScriptEditor := (self playerClass includesSelector: selector)
						ifTrue: [Preferences universalTiles
								ifFalse: [self error: 'duplicate selector'].
							ScriptEditorMorph new fromExistingMethod: selector forPlayer: t1]
						ifFalse: [ScriptEditorMorph new setMorph: t1 costume scriptName: selector].
			(defaultStatus == #ticking
					and: [selector numArgs == 0])
				ifTrue: [t1 costume arrangeToStartStepping]].
	logger targetScriptEditor: currentScriptEditor.
	^ currentScriptEditor! !

!UniclassScript methodsFor: '*CreW-Logger' stamp: 'ms 10/26/2006 01:42'!
logger
	logger ifNil:[
		logger _ ScriptLogger new: self currentScriptEditor
	].
	^ logger.! !

MethodWithInterface subclass: #UniclassScript
	instanceVariableNames: 'currentScriptEditor formerScriptingTiles isTextuallyCoded lastSourceString logger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Scripting'!

!UniclassScript reorganize!
('initialization' convertFromUserScript: initialize isTextuallyCoded playerClass:selector: printOn:)
('initialize-release' releaseCachedState)
('script editor' currentScriptEditor currentScriptEditor: currentScriptEditorDo: instantiatedScriptEditorForPlayer: recompileScriptFromTilesUnlessTextuallyCoded)
('textually coded' becomeTextuallyCoded lastSourceString)
('updating' bringUpToDate revertToLastSavedTileVersionFor: saveScriptVersion:)
('versions' recreateScriptFrom: revertScriptVersionFrom: savedTileVersionsCount)
('access' playerClass playerClassPerSe)
('*CreW-Logger' logger)
!

AlignmentMorph subclass: #ScriptEditorMorph
	instanceVariableNames: 'scriptName firstTileRow timeStamp playerScripted handWithTile showingMethodPane threadPolygon'
	classVariableNames: 'WritingUniversalTiles'
	poolDictionaries: ''
	category: 'Morphic-Scripting'!
