﻿'From Squeakland 3.8-05 of 1 September 2005 [latest update: #527] on 7 November 2006 at 12:13:53 am'!

!DamaUtil class methodsFor: 'flap' stamp: 'ko 11/7/2006 00:13'!
editNavigatorFlap
	Browser
		openMessageBrowserForClass: ProjectNavigationMorph
		selector: #makeTheSimpleButtons
		editString: nil! !

!DamaUtil class methodsFor: 'flap' stamp: 'ko 11/7/2006 00:11'!
editSupplyFlap
	Browser
		openMessageBrowserForClass: Flaps class
		selector: #defaultsQuadsDefiningPlugInSuppliesFlap
		editString: nil! !

!DamaUtil class methodsFor: 'flap' stamp: 'ko 11/6/2006 23:48'!
resetNavigatorFlap
	| navigatorFlap |

	"ナビゲータフラップを削除する"
	(Flaps globalFlapTabsIfAny
		select: [:t2 | t2 labelString = 'Navigator' translated])
		do: [:t2 | Flaps removeFlapTab: t2 keepInList: false].

	"ナビゲータフラップのインスタンスを作成する"
	Flaps initialize.

	"ナビゲータフラップを取得して、配置する"
	navigatorFlap := Flaps newNavigatorFlap.
	Flaps addGlobalFlap: navigatorFlap.
	Flaps enableGlobalFlaps!]lang[(41 14 149 21 24 19 105)0,5,0,5,0,5,0! !

!DamaUtil class methodsFor: 'flap' stamp: 'ko 11/6/2006 23:44'!
resetSupplyFlap
	| supplyFlap |

	"既存の「部品」フラップを削除する"
	(Flaps globalFlapTabsIfAny
		select: [:t2 | t2 labelString = 'Supplies' translated])
		do: [:t2 | Flaps removeFlapTab: t2 keepInList: false].

	"新しい「部品」フラップのインスタンスを作成する"
	Flaps initialize.

	"新しい「部品」フラップを取得して、配置する"
	supplyFlap := Flaps newSuppliesFlapFromQuads: Flaps quadsDefiningPlugInSuppliesFlap positioning: #right.
	supplyFlap referent setNameTo: 'Supplies Flap' translated.
	Flaps addGlobalFlap: supplyFlap.
	Flaps enableGlobalFlaps!]lang[(35 16 148 23 24 21 226)0,5,0,5,0,5,0! !


!ProjectNavigationMorph methodsFor: 'buttons' stamp: 'ko 11/6/2006 23:57'!
makeTheSimpleButtons
	^ {self buttonNewProject. self buttonPrev. self buttonNext. self buttonPaint}
		, (Preferences includeSoundControlInNavigator
				ifTrue: [{self buttonSound}]
				ifFalse: [#()]) , { self buttonQuit}

"消されてしまったボタンを復活させるには、以下のコマンドを適宜挿入のこと
	・フルスクリーン：self buttonFullScreen
	・元にもどす：self buttonUndo
	・言語ボタン：self buttonLanguage
	・探す：self buttonFind
	・プロジェクトを保存する：self buttonPublish
"!]lang[(224 35 2 9 23 7 17 7 21 4 17 13 20)0,5,0,5,0,5,0,5,0,5,0,5,0! !


!TheWorldMenu methodsFor: 'construction' stamp: 'ko 11/7/2006 00:09'!
helpMenu
        "Build the help menu for the world."
        |  menu |

  	menu := self menu: 'help...'.

        self fillIn: menu from:
        {
                {'about this system...'. {SmalltalkImage current. #aboutThisSystem}. 'current version information.'}.
                {'update code from server'. {Utilities. #updateFromServer}. 'load latest code updates via the internet'}.
                {'preferences...'. {Preferences. #openPreferencesInspector}. 'view and change various options.'}.
			 {'set language...' . {Project. #chooseNaturalLanguage}. 'choose the language in which tiles should be displayed.'} .
			nil.
			{'カテゴリレベルを変更...' . { KotodamaCategoryMenu . #chooseCategoryLevel}. 'change Kotodama Category Level'}.
			{'ことだまonSqueakのバージョン表示...' . { KotodamaVersion . #showVersion } . 'show Kotodama Version' }.
                nil.
			{'部品フラップ初期化...'. {DamaUtil. #resetSupplyFlap}. 'SupplyFlap reset'}.
			{'部品フラップ編集...'. {DamaUtil. #editSupplyFlap}. 'SupplyFlap edit'}.
			{'ナビゲータフラップ初期化...'. {DamaUtil. #resetNavigatorFlap}. 'NavigatorFlap reset'}.
			{'ナビゲータフラップ編集...'. {DamaUtil. #editNavigatorFlap}. 'NavigatorFlap edit'}.
			nil.
               {'command-key help'. { Utilities . #openCommandKeyHelp}. 'summary of keyboard shortcuts.'}
	}.

	self addGestureHelpItemsTo: menu.

	self fillIn: menu from:
	{
                {'world menu help'. { self . #worldMenuHelp}. 'helps find menu items buried in submenus.'}.
                        "{'info about flaps' . { Utilities . #explainFlaps}. 'describes how to enable and use flaps.'}."
                {'font size summary' . { TextStyle . #fontSizeSummary}.  'summary of names and sizes of available fonts.'}.
                {'useful expressions' . { Utilities . #openStandardWorkspace}. 'a window full of useful expressions.'}.
			 {'annotation setup...' . { Preferences . #editAnnotations}. 'Click here to get a little window that will allow you to specify which types of annotations, in which order, you wish to see in the annotation panes of browsers and other tools'}.
			nil.
                {'graphical imports' . { Imports default . #viewImages}.  'view the global repository called ImageImports; you can easily import external graphics into ImageImports via the FileList'}.
                {'standard graphics library' . { ScriptingSystem . #inspectFormDictionary}.  'lets you view and change the system''s standard library of graphics.'}.
                nil.
                {'telemorphic...' . {self. #remoteDo}.  'commands for doing multi-machine "telemorphic" experiments'}.
                {#soundEnablingString . { Preferences . #toggleSoundEnabling}. 'turning sound off will completely disable Squeak''s use of sound.'}.
                {'definition for...' . { Utilities . #lookUpDefinition}.  'if connected to the internet, use this to look up the definition of an English word.'}.
                nil.

                {'set author initials...' . { Utilities . #setAuthorInitials }. 'supply initials to be used to identify the author of code and other content.'}.
                {'vm statistics' . { self . #vmStatistics}.  'obtain some intriguing data about the vm.'}.
			  nil.
			  {'purge undo records' . { CommandHistory . #resetAllHistory }. 'save space by removing all the undo information remembered in all projects.'}.
                {'space left' . { self . #garbageCollect}. 'perform a full garbage-collection and report how many bytes of space remain in the image.'}.
        }.

	^menu

!]lang[(637 10 95 4 8 8 97 9 62 8 60 12 68 11 2410)0,5,0,5,0,5,0,5,0,5,0,5,0,5,0! !

DamaUtil class removeSelector: #editNavigatiorFlap!

!DamaUtil class reorganize!
('as yet unclassified' makeDefaultTile:)
('flap' editNavigatorFlap editSupplyFlap resetNavigatorFlap resetSupplyFlap)
!

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

DamaUtil resetNavigatorFlap.
DamaUtil resetSupplyFlap.!

